//+------------------------------------------------------------------+
//|                                     OpenOrderMarketExecution.mq4 |
//|                              Copyright  2011, Khlystov Vladimir |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Khlystov Vladimir"
#property link      "cmillion@narod.ru"
#property show_inputs
//--------------------------------------------------------------------
extern string  _="(0) -  SL; (-1)   (-2)  ";
extern int     stoploss    = -2,       //  SL,  0,  SL    - 1     -2   
               takeprofit  = 0,        //  TP,  0,  TP  
               Magic       = 777,      //  
               Orders      = 1;        //-  
extern bool    SELL        = true,     //  SELL
               BUY         = true;     //  BUY
extern double  Lot         = 0.0;      // 
extern int     Risk        = 1;        //%     ,   Lot=0
extern int     slippage    = 5;        //      
extern bool    MarketExecution = true; //    
extern string  _="";
extern int Fractal = 10;  //         
extern string  _="";
extern int Zigzag_Depth       = 12;
extern int Zigzag_Deviation   = 5;
extern int Zigzag_Backstep    = 3;
extern int     Delta          = 1;     //        
//--------------------------------------------------------------------
int start()
{
   int stoplossB,stoplossS,i,Ticket;
   if (stoploss > 0) {stoplossB = stoploss; stoplossS = stoploss;} 
   else
   {
      double FrUp,FrDn;
      if (stoploss == -1)
      {
         //-----------------------------------------------------------------------    Fr
         for (i=Fractal; i<500; i++) //    FrUp
         {
            FrUp = Fractal(MODE_UPPER,i);
            if (FrUp==0) continue;
            stoplossS = (FrUp - Ask) / Point + Delta;
            break;
         }
         for (i=Fractal; i<500; i++) //    FrDn
         {
            FrDn = Fractal(MODE_LOWER,i);
            if (FrDn==0) continue;
            stoplossB = (Bid - FrDn) / Point + Delta;
            break;
         }
      }
      if (stoploss == -2)
      {
         //-----------------------------------------------------------------------   
         for (int j=0; j<500; j++) //    FrUp
         {
            FrUp = NormalizeDouble(iCustom(NULL,0,"ZigZag",Zigzag_Depth,Zigzag_Deviation,Zigzag_Backstep,0,j), Digits);
            break;
         }
         for (i=j+1; i<500; i++) //    FrUp
         {
            FrUp = NormalizeDouble(iCustom(NULL,0,"ZigZag",Zigzag_Depth,Zigzag_Deviation,Zigzag_Backstep,0,i), Digits);
            if (FrUp!=High[i]) continue;
            stoplossS = (FrUp - Ask) / Point + Delta;
            break;
         }
         for (i=j+1; i<500; i++) //    FrDn
         {
            FrDn = NormalizeDouble(iCustom(NULL,0,"ZigZag",Zigzag_Depth,Zigzag_Deviation,Zigzag_Backstep,0,i), Digits);
            if (FrDn!=Low[i]) continue;
            stoplossB = (Bid - FrDn) / Point + Delta;
            break;
         }
      }
   }
   string txt =StringConcatenate("OpenOrderMarketExecution Copyright  2011, cmillion@narod.ru  time ",TimeToStr(TimeCurrent(),TIME_SECONDS),"\n","\n");
   if (BUY ) 
   {
      if (stoploss!=0)   txt =StringConcatenate(txt,"Open BUY    SL =",DoubleToStr(Bid - stoplossB*Point,Digits),"  ",stoplossB," ");
      if (takeprofit!=0) txt =StringConcatenate(txt,"   TP =",DoubleToStr(Ask + takeprofit*Point,Digits),"  ",takeprofit," ","\n");
      else txt =StringConcatenate(txt,"\n");
   }
   if (SELL) 
   {
      if (stoploss!=0)   txt =StringConcatenate(txt,"Open SELL   SL =",DoubleToStr(Ask + stoplossS*Point,Digits),"  ",stoplossS," ");
      if (takeprofit!=0) txt =StringConcatenate(txt,"   TP =",DoubleToStr(Bid - takeprofit*Point,Digits),"  ",takeprofit," ","\n");
      else txt =StringConcatenate(txt,"\n");
   }
   double MinLot = MarketInfo(Symbol(),MODE_MINLOT);
   double Maxlot = MarketInfo(Symbol(),MODE_MAXLOT);
   int OkrLOT;
   if (MinLot==0.01) OkrLOT = 2;
   if (MinLot >0.01) OkrLOT = 1;
   if (MinLot >0.1 ) OkrLOT = 0;
   Comment(txt);
   //---
   double SL=0,TP=0;
   for (i=0; i<Orders; i++)
   {  
      SL=0;TP=0;
      if (BUY)
      {
         RefreshRates();
         if (Lot==0) 
         if (stoplossB==0) {Alert("stoploss    = 0   % ");return;} 
         else Lot = NormalizeDouble(AccountFreeMargin()*Risk/100/MarketInfo(Symbol(),MODE_TICKVALUE)/stoplossB,OkrLOT);
         if (Lot<MinLot) {Lot=MinLot;txt =StringConcatenate(txt,"  ");}
         if (Lot>Maxlot) {Lot=Maxlot;txt =StringConcatenate(txt,"  ");}
         txt =StringConcatenate(txt,"Lot Buy =",Lot,"\n");
         if (!MarketExecution)
         {
            if (takeprofit!=0) TP  = NormalizeDouble(Ask + takeprofit*Point,Digits); else TP=0;
            if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoplossB*Point,Digits); else SL=0;     
         }
         Ticket = OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),slippage,SL,TP,"BUY",Magic,0,Blue);
         if (Ticket!=-1)
         {
            Alert(" ",Ticket,"  ,  SL=",SL," TP=",TP);
            if (MarketExecution)
            {
               if (takeprofit!=0) TP  = NormalizeDouble(Ask + takeprofit*Point,Digits); else TP=0;
               if (stoploss!=0)   SL  = NormalizeDouble(Bid - stoplossB*Point,Digits); else SL=0;     
               if (OrderModify(Ticket,NormalizeDouble(Ask,Digits),SL,TP,0,White)) Alert("  ",Ticket,"  ,  SL=",SL," TP=",TP);
               else Print(Symbol()," ",ShowERROR());
            }
         }
         else Alert("   ",ShowERROR()," =",NormalizeDouble(Ask,Digits)," SL=",SL," TP=",TP);
      }
      SL=0;TP=0;
      if (SELL)
      {  
         RefreshRates();
         if (Lot==0) 
         if (stoplossS==0) {Alert("stoploss    = 0   % ");return;} 
         else Lot = NormalizeDouble(AccountFreeMargin()*Risk/100/MarketInfo(Symbol(),MODE_TICKVALUE)/stoplossS,OkrLOT);
         if (Lot<MinLot) {Lot=MinLot;txt =StringConcatenate(txt,"  ");}
         if (Lot>Maxlot) {Lot=Maxlot;txt =StringConcatenate(txt,"  ");}
         txt =StringConcatenate(txt,"Lot Sell =",Lot,"\n");
         if (!MarketExecution)
         {
            if (takeprofit!=0) TP = NormalizeDouble(Bid - takeprofit*Point,Digits); else TP=0;
            if (stoploss!=0)   SL = NormalizeDouble(Ask + stoplossS*Point,Digits);  else SL=0;   
         }         
         Ticket = OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),slippage,SL,TP,"SELL",Magic,0,Red);  
         if (Ticket!=-1)
         {
            Alert(" ",Ticket,"  ,  SL=",SL," TP=",TP);
            if (MarketExecution)
            {
               if (takeprofit!=0) TP = NormalizeDouble(Bid - takeprofit*Point,Digits); else TP=0;
               if (stoploss!=0)   SL = NormalizeDouble(Ask + stoplossS*Point,Digits);  else SL=0;   
               if (OrderModify(Ticket,NormalizeDouble(Bid,Digits),SL,TP,0,White)) Alert("  ",Ticket,"  ,  SL=",SL," TP=",TP);
               else Print(Symbol()," ",ShowERROR());
            }
         }
         else Alert("   ",ShowERROR()," =",NormalizeDouble(Ask,Digits)," SL=",SL," TP=",TP);
      }
   }
   Comment(txt,"\n","\n","    ",TimeToStr(TimeCurrent(),TIME_SECONDS));
return(0);
}
//--------------------------------------------------------------------
string ShowERROR()
{
   int err=GetLastError();
   string com;
   switch ( err )
   {                  
      case 0:   return;
      case 1:   return;
      case 2:   com=StringConcatenate(com,"        ");break;
      case 3:   com=StringConcatenate(com,"            ");break;
      case 130: com=StringConcatenate(com,"                     ");break;
      case 134: com=StringConcatenate(com,"                ");break;
      case 136: com=StringConcatenate(com,"                           ");break;
      case 146: com=StringConcatenate(com,"         ");break;
      case 129: com=StringConcatenate(com,"                 ");break;
      case 131: com=StringConcatenate(com,"                ");break;
      case 137: com=StringConcatenate(com,"                      ");break;
      case 138: com=StringConcatenate(com,"                        ");break;
      case 4109: com=StringConcatenate(com,"   .    (  )   .");break;
      default:  com=StringConcatenate(com," Error " ,err);break;
   }
   return(com);
}
//--------------------------------------------------------------------
double Fractal(int tip,int bar)
{
   int i,n;
   double fr,fr1;
   if (tip==MODE_UPPER)
   {
      fr1 = iHigh(NULL,0,bar);
      i=bar;n=0;
      while (true)
      {
         i++; 
         if (i>Bars) return(0);
         fr = iHigh(NULL,0,i);
         n++;
         if (n>=Fractal) break;
         if (fr>fr1) return(0);
      }
      i=bar;n=0;
      while (true)
      {
         i--;
         if (i==0) return(0);
         fr = iHigh(NULL,0,i);
         n++;
         if (n>=Fractal) break;
         if (fr>fr1) return(0);
      }
      return(fr1);
   }
   if (tip==MODE_LOWER)
   {
      fr1 = iLow(NULL,0,bar);
      i=bar;n=0;
      while (true)
      {
         i++; 
         if (i>Bars) return(0);
         fr = iLow(NULL,0,i);
         n++;
         if (n>=Fractal) break;
         if (fr<fr1) return(0);
      }
      i=bar;n=0;
      while (true)
      {
         i--; 
         if (i==0) return(0);
         fr = iLow(NULL,0,i);
         n++;
         if (n>=Fractal) break;
         if (fr<fr1) return(0);
      }
      return(fr1);
   }
}
//+------------------------------------------------------------------+

